Index: NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DOM/domain.F90
===================================================================
--- NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DOM/domain.F90	(revision 14428)
+++ NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DOM/domain.F90	(revision 14547)
@@ -91,5 +91,4 @@
       INTEGER ::   ji, jj, jk, jt   ! dummy loop indices
       INTEGER ::   iconf = 0    ! local integers
-      REAL(wp)::   zrdt
       CHARACTER (len=64) ::   cform = "(A12, 3(A13, I7))"
       INTEGER , DIMENSION(jpi,jpj) ::   ik_top , ik_bot       ! top and bottom ocean level
@@ -372,6 +371,25 @@
       !
       ! set current model timestep rDt = 2*rn_Dt if MLF or rDt = rn_Dt if RK3
+#if defined key_RK3
+      rDt   =         rn_Dt
+      r1_Dt = 1._wp / rDt
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '           ===>>>   Runge Kutta 3rd order (RK3) :   rDt = ', rDt
+         WRITE(numout,*)
+      ENDIF
+      !
+#else
       rDt   = 2._wp * rn_Dt
       r1_Dt = 1._wp / rDt
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '           ===>>>   Modified Leap-Frog (MLF) :   rDt = ', rDt
+         WRITE(numout,*)
+      ENDIF
+      !
+#endif
       !
       IF( l_SAS .AND. .NOT.ln_linssh ) THEN
Index: NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DYN/divhor.F90
===================================================================
--- NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DYN/divhor.F90	(revision 14428)
+++ NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DYN/divhor.F90	(revision 14547)
@@ -13,4 +13,5 @@
    !!             -   ! 2014-12  (G. Madec) suppression of cross land advection option
    !!             -   ! 2015-10  (G. Madec) add velocity and rnf flag in argument of div_hor
+   !!            4.5  ! 2015-10  (S. Techene, G. Madec)  hdiv replaced by e3divUh
    !!----------------------------------------------------------------------
 
@@ -36,5 +37,10 @@
    PRIVATE
 
-   PUBLIC   div_hor    ! routine called by step.F90 and istate.F90
+   !                  !! * Interface
+   INTERFACE div_hor
+      MODULE PROCEDURE div_hor_RK3, div_hor_old
+   END INTERFACE
+
+   PUBLIC   div_hor    ! routine called by ssh_nxt.F90 and istate.F90
 
    !! * Substitutions
@@ -48,5 +54,65 @@
 CONTAINS
 
-   SUBROUTINE div_hor( kt, Kbb, Kmm )
+   SUBROUTINE div_hor_RK3( kt, Kbb, Kmm, puu, pvv, pe3divUh )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE div_hor_RK3  ***
+      !!                    
+      !! ** Purpose :   compute the horizontal divergence at now time-step
+      !!
+      !! ** Method  :   the now divergence is computed as :
+      !!         hdiv = 1/(e1e2t*e3t) ( di[e2u*e3u un] + dj[e1v*e3v vn] )
+      !!      and correct with runoff inflow (div_rnf) and cross land flow (div_cla) 
+      !!
+      !! ** Action  : - thickness weighted horizontal divergence of in input velocity (puu,pvv)
+      !!----------------------------------------------------------------------
+      INTEGER                         , INTENT(in   ) ::   kt, Kbb, Kmm   ! ocean time-step & time-level indices
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   puu, pvv       ! horizontal velocity
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   pe3divUh       ! e3t*div[Uh]
+      !
+      INTEGER  ::   ji, jj, jk    ! dummy loop indices
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('div_hor_RK3')
+      !
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'div_hor_RK3 : thickness weighted horizontal divergence '
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+         hdiv    (:,:,:) = 0._wp    ! initialize hdiv & pe3divUh for the halos and jpk level at the first time step
+      ENDIF
+      ! 
+      pe3divUh(:,:,:) = 0._wp    !!gm to be applied to the halos only
+      !
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )                                                  
+         hdiv(ji,jj,jk) = (   e2u(ji  ,jj) * e3u(ji  ,jj,jk,Kmm) * puu(ji  ,jj,jk)      &
+            &               - e2u(ji-1,jj) * e3u(ji-1,jj,jk,Kmm) * puu(ji-1,jj,jk)      &
+            &               + e1v(ji,jj  ) * e3v(ji,jj  ,jk,Kmm) * pvv(ji,jj  ,jk)      &
+            &               - e1v(ji,jj-1) * e3v(ji,jj-1,jk,Kmm) * pvv(ji,jj-1,jk)  )   &
+            &            * r1_e1e2t(ji,jj) / e3t(ji,jj,jk,Kmm)
+      END_3D
+      !
+      IF( ln_rnf )   CALL sbc_rnf_div( hdiv, Kmm )             !==  + runoffs divergence  ==!
+      !
+#if defined key_asminc 
+      IF( ln_sshinc .AND. ln_asmiau )   &                      !==  + SSH assimilation increment  ==!
+         &           CALL ssh_asm_div( kt, Kbb, Kmm, hdiv )
+#endif
+      !
+      IF( ln_isf )   CALL isf_hdiv( kt, Kmm, hdiv )            !==  + ice-shelf mass exchange ==!
+      !
+!!gm Patch before suppression of hdiv from all modules that use it
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )                            !==  e3t * Horizontal divergence  ==!
+         pe3divUh(ji,jj,jk) = hdiv(ji,jj,jk) * e3t(ji,jj,jk,Kmm)
+      END_3D
+!!gm end
+      !
+      CALL lbc_lnk( 'divhor', hdiv, 'T', 1._wp )   !   (no sign change)
+      !
+      IF( ln_timing )   CALL timing_stop('div_hor_RK3')
+      !
+   END SUBROUTINE div_hor_RK3
+
+
+   SUBROUTINE div_hor_old( kt, Kbb, Kmm )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE div_hor  ***
@@ -64,6 +130,4 @@
       !
       INTEGER  ::   ji, jj, jk    ! dummy loop indices
-      REAL(wp) ::   zraur, zdep   ! local scalars
-      REAL(wp), DIMENSION(jpi,jpj) :: ztmp
       !!----------------------------------------------------------------------
       !
@@ -98,5 +162,5 @@
       IF( ln_timing )   CALL timing_stop('div_hor')
       !
-   END SUBROUTINE div_hor
+   END SUBROUTINE div_hor_old
    
    !!======================================================================
Index: NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DYN/dynspg.F90
===================================================================
--- NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DYN/dynspg.F90	(revision 14428)
+++ NEMO/branches/2021/dev_r14318_RK3_stage1/src/OCE/DYN/dynspg.F90	(revision 14547)
@@ -57,5 +57,5 @@
 CONTAINS
 
-   SUBROUTINE dyn_spg( kt, Kbb, Kmm, Krhs, puu, pvv, pssh, puu_b, pvv_b, Kaa, k_only_ADV )
+   SUBROUTINE dyn_spg( kt, Kbb, Kmm, Krhs, puu, pvv, pssh, puu_b, pvv_b, Kaa )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dyn_spg  ***
@@ -79,8 +79,7 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpt), INTENT(inout) ::  puu, pvv            ! ocean velocities and RHS of momentum equation
       REAL(wp), DIMENSION(jpi,jpj,jpt)    , INTENT(inout) ::  pssh, puu_b, pvv_b  ! SSH and barotropic velocities at main time levels
-      INTEGER , OPTIONAL                  , INTENT( in )  ::  k_only_ADV          ! only Advection in the RHS
       !
       INTEGER  ::   ji, jj, jk                   ! dummy loop indices
-      REAL(wp) ::   z2dt, zg_2, zintp, zgrho0r, zld   ! local scalars
+      REAL(wp) ::   zg_2, zintp, zgrho0r, zld    ! local scalars
       REAL(wp)             , DIMENSION(jpi,jpj) ::   zpgu, zpgv   ! 2D workspace
       REAL(wp), ALLOCATABLE, DIMENSION(:,:)     ::   zpice
@@ -151,6 +150,6 @@
          IF( ln_wave .and. ln_bern_srfc ) THEN          !== Add J terms: depth-independent Bernoulli head
             DO_2D( 0, 0, 0, 0 )
-               zpgu(ji,jj) = zpgu(ji,jj) + ( bhd_wave(ji+1,jj) - bhd_wave(ji,jj) ) / e1u(ji,jj)   !++ bhd_wave from wave model in m2/s2 [BHD parameters in WW3]
-               zpgv(ji,jj) = zpgv(ji,jj) + ( bhd_wave(ji,jj+1) - bhd_wave(ji,jj) ) / e2v(ji,jj)
+               zpgu(ji,jj) = zpgu(ji,jj) + ( bhd_wave(ji+1,jj) - bhd_wave(ji,jj) ) * r1_e1u(ji,jj)   !++ bhd_wave from wave model in m2/s2 [BHD parameters in WW3]
+               zpgv(ji,jj) = zpgv(ji,jj) + ( bhd_wave(ji,jj+1) - bhd_wave(ji,jj) ) * r1_e2v(ji,jj)
             END_2D
          ENDIF
@@ -167,5 +166,5 @@
       SELECT CASE ( nspg )                   !== surface pressure gradient computed and add to the general trend ==!
       CASE ( np_EXP )   ;   CALL dyn_spg_exp( kt,      Kmm,       puu, pvv, Krhs )                    ! explicit
-      CASE ( np_TS  )   ;   CALL dyn_spg_ts ( kt, Kbb, Kmm, Krhs, puu, pvv, pssh, puu_b, pvv_b, Kaa, k_only_ADV ) ! time-splitting
+      CASE ( np_TS  )   ;   CALL dyn_spg_ts ( kt, Kbb, Kmm, Krhs, puu, pvv, pssh, puu_b, pvv_b, Kaa ) ! time-splitting
       END SELECT
       !
